//----------------------------------------------------------------------------------------------------------------------
// Control Functions
//----------------------------------------------------------------------------------------------------------------------
HMENU AppendMainMenu(void* pMenu, ...);
HMENU AppendPopupMenu(void* pMenu, ...);
HMENU _vectorcall InsertMainMenu(void* pMenu, int iPosition = -1);
HMENU _vectorcall InsertPopupMenu(void* pMenu, int iPosition = -1);
void SelectPopupMenu(WCHAR* pName);
HWND SetWindowToolbar(void* pTool);
HWND SetWindowToolbox(void* pTool);
void _vectorcall EnableMainMenuItem(WCHAR* pName, BYTE oStart, BYTE oEnd, bool bEnable);
void _vectorcall EnablePopupMenuItem(WCHAR* pName, BYTE oStart, BYTE oEnd, bool bEnable);
void _vectorcall EnableToolbarButton(BYTE oStart, BYTE oEnd, bool bEnable);
void _vectorcall EnableToolboxButton(BYTE oStart, BYTE oEnd, bool bEnable);
HWND _vectorcall SetWindowTreeview(WORD wX, void* pTree);
void _vectorcall InsertTreeviewItem(void* pTree, HANDLE hItem = nullptr, int iAfter = -1);
void ExpandTreeviewItem(HANDLE hItem, bool bExpand);
void RemoveTreeviewItem(HANDLE hItem = nullptr, int iAfter = 0);
void SetTreeviewName(WCHAR* pName, HANDLE hItem = nullptr);
void SetTreeviewColor(UINT uColor);
HWND SetWindowStatusbar(int* iPart);
void DrawStatusbarText(BYTE oIndex, WCHAR* pFormat, ...);
HANDLE GetTreeviewItem(WCHAR* pName = nullptr);
WCHAR* GetTreeviewName();
UINT GetTreeviewColor();
UINT GetTreeviewCount();
WCHAR* GetSelectFolder(WCHAR* pName = nullptr);
WCHAR* _vectorcall GetOpenFile(WCHAR* pName = nullptr, WCHAR* pFilter = nullptr);
WCHAR* _vectorcall GetSaveFile(WCHAR* pName = nullptr, WCHAR* pFilter = nullptr);
bool _vectorcall GetInputData(short sX, short sY, void* pList, void* pCheck = nullptr, bool bEdit = false);
void _vectorcall ResetInputData(void* pList, void* pCheck, bool bEdit);
void _vectorcall ShowAboutDialog(short sX, short sY, WORD wX, WORD wY, WCHAR* pTitle, WCHAR* pText);
