//----------------------------------------------------------------------------------------------------------------------
// Graph Functions
//----------------------------------------------------------------------------------------------------------------------
HANDLE _vectorcall CreateGraph(AXPLOT* pVertex, UINT uVertex, UINT* pIndex, UINT uIndex);
HANDLE _vectorcall CreateGraph(XMFLOAT3 fS, WORD wX, WORD wY, float* pData);
HANDLE _vectorcall LoadGraph(XMFLOAT3 fS, void* pRfm, int iRfm = 0);
void _vectorcall SetGraphMaterial(float fAmbient, float fDiffuse, float fAlpha);
void _vectorcall SetGraphLegend(WCHAR* pTitle, float fMin, float fMax, BYTE oInt = 0, bool bReverse = false);
void _vectorcall DrawGraph(HANDLE hGraph, bool bFill = false, bool bContour = false, bool bLegend = false);
void RemoveGraph(HANDLE hGraph);
bool GraphExisting(HANDLE hGraph);
void _vectorcall DrawLine(XMFLOAT3 fV0, XMFLOAT3 fV1, UINT uColor[2] = nullptr);
void _vectorcall DrawRectangle(XMFLOAT3 fO, XMFLOAT3 fH, XMFLOAT3 fD, XMFLOAT2 fS, UINT uColor[4] = nullptr);
void _vectorcall DrawEllipse(XMFLOAT3 fO, XMFLOAT3 fH, XMFLOAT3 fD, XMFLOAT2 fS, UINT uColor, bool bFill = false);
void _vectorcall DrawTriad(XMFLOAT3 fO, XMFLOAT3 fH, XMFLOAT3 fD, float fAxis, float fBall = 0, bool bFill = false);
void _vectorcall DrawButton(XMFLOAT3 fP, XMFLOAT2 fS, XMFLOAT2 fT, UINT uColor[8]);
void _vectorcall DrawBox(XMFLOAT3 fV[8], UINT uColor[8]);
void _vectorcall DrawTriangle(XMFLOAT3* fV, UINT* uColor, UINT nVertex, UINT* uIndex, UINT nIndex);
void _vectorcall DrawCameraFrustum(HANDLE hCamera, UINT uColor, float fTriad = 0);
void _vectorcall DrawGraphVolume(HANDLE hGraph, UINT uColor, float fTriad = 0);
void _vectorcall DrawLightGeometry(HANDLE hLight, float fAlpha, BYTE oLevel = 0, float fTriad = 0, float fSize = 0);
void _vectorcall DrawObjectVolume(HANDLE hObject, UINT uColor, float fTriad = 0);
void _vectorcall DrawTerrainVolume(HANDLE hTerrain, UINT uColor, float fTriad = 0);
