//----------------------------------------------------------------------------------------------------------------------
// Input Functions
//----------------------------------------------------------------------------------------------------------------------
BYTE GetVirtualKey();
BYTE GetVirtualKeyPressed();
BYTE _vectorcall WaitVirtualKeyDown(float fDelay = 0);
BYTE _vectorcall WaitVirtualKeyUp(float fDelay = 0);
bool PollVirtualKey(BYTE oKey);
bool PollUpKey();
bool PollDownKey();
bool PollLeftKey();
bool PollRightKey();
bool PollLeftShiftKey();
bool PollRightShiftKey();
bool PollShiftKey();
bool PollLeftControlKey();
bool PollRightControlKey();
bool PollControlKey();
bool PollLeftMenuKey();
bool PollRightMenuKey();
bool PollMenuKey();
bool PollEscapeKey();
bool PollReturnKey();
bool PollSpaceKey();
BYTE GetKeyPressed();
BYTE _vectorcall WaitKeyDown(float fDelay = 0);
BYTE _vectorcall WaitKeyUp(float fDelay = 0);
void SetMouseCursor(WORD wCursor);
void SetMousePosition(short sX, short sY);
WORD GetMouseCursor();
BYTE GetMouseButton();
BYTE GetMouseClicked();
void GetMousePosition(short& sX, short& sY);
BYTE _vectorcall GetMouseMove(BYTE oKey, short& sX, short& sY, short& sZ);
BYTE _vectorcall WaitMouseDown(float fDelay = 0);
BYTE _vectorcall WaitMouseUp(float fDelay = 0);
bool QueryController(BYTE oController);
bool PollGamepadUp(BYTE oController);
bool PollGamepadDown(BYTE oController);
bool PollGamepadLeft(BYTE oController);
bool PollGamepadRight(BYTE oController);
bool PollButtonStart(BYTE oController);
bool PollButtonBack(BYTE oController);
bool PollButtonLeftThumb(BYTE oController);
bool PollButtonRightThumb(BYTE oController);
bool PollButtonLeftShoulder(BYTE oController);
bool PollButtonRightShoulder(BYTE oController);
bool PollButtonA(BYTE oController);
bool PollButtonB(BYTE oController);
bool PollButtonX(BYTE oController);
bool PollButtonY(BYTE oController);
BYTE GetLeftTrigger(BYTE oController);
BYTE GetRightTrigger(BYTE oController);
short GetLeftThumbX(BYTE oController);
short GetLeftThumbY(BYTE oController);
short GetRightThumbX(BYTE oController);
short GetRightThumbY(BYTE oController);
WORD _vectorcall GetKeyStroke(BYTE oController, bool bReleased = false);
void _vectorcall ShakeController(BYTE oController, WORD wLeft, WORD wRight);
