//----------------------------------------------------------------------------------------------------------------------
// State Functions
//----------------------------------------------------------------------------------------------------------------------
void SetShadowMap(WORD wX, WORD wY);
void EnableShadowMap(bool bEnable);
bool ShadowMapEnabled();
void DrawShadowMap(XMFLOAT3 fP, XMFLOAT3 fR = { 0, 0, 0 }, float fScale = 1);
void _vectorcall DrawShadowMap(short sX = 0, short sY = 0, float fScale = 1);
void _vectorcall SetMirrorReflection(float fRatio);
float _vectorcall GetMirrorReflection();
void DrawMirrorImage(HANDLE hImage, XMFLOAT3 fP, XMFLOAT3 fR = { 0, 0, 0 }, float fScale = 1);
void _vectorcall SetShaderVariable(float fVariable);
float _vectorcall GetShaderVariable();
void _vectorcall SetTextScale(float fScale);
void SetLineThickness(BYTE oThickness);
void SetRotationAngle(short sDegree);
void SetDisplayInputHook(void* pInput);
void SetWindowCloseHook(void* pClose);
void EnableSmallIcon(bool bEnable);
void EnableVerticalSync(bool bEnable);
void DisableMusicPause(bool bDisable);
void DisableWindowClose(bool bDisable);
void DisableAutoShadowing(bool bDisable);
void DisableAutoSpotlight(bool bDisable);
void DisableAlphaBlending(bool bDisable);
void DisablePhongShading(bool bEnable);
void DisableSolidFilling(bool bDisable);
void DisableBackCulling(bool bDisable);
UINT GetCameraTotal();
UINT GetCanvasTotal();
UINT GetGraphTotal();
UINT GetImageTotal();
UINT GetLightTotal();
UINT GetMusicTotal();
UINT GetObjectTotal();
UINT GetParticleTotal();
UINT GetSkyboxTotal();
UINT GetSoundTotal();
UINT GetSpriteTotal();
UINT GetTerrainTotal();
UINT GetTimerTotal();
void ReportCamera(WCHAR* pFile, bool bAppend = false);
void ReportCanvas(WCHAR* pFile, bool bAppend = false);
void ReportGraph(WCHAR* pFile, bool bAppend = false);
void ReportImage(WCHAR* pFile, bool bAppend = false);
void ReportLight(WCHAR* pFile, bool bAppend = false);
void ReportMusic(WCHAR* pFile, bool bAppend = false);
void ReportObject(WCHAR* pFile, bool bAppend = false);
void ReportParticle(WCHAR* pFile, bool bAppend = false);
void ReportShortcut(WCHAR* pFile, bool bAppend = false);
void ReportSkybox(WCHAR* pFile, bool bAppend = false);
void ReportSound(WCHAR* pFile, bool bAppend = false);
void ReportSprite(WCHAR* pFile, bool bAppend = false);
void ReportTerrain(WCHAR* pFile, bool bAppend = false);
void ReportTimer(WCHAR* pFile, bool bAppend = false);
