//----------------------------------------------------------------------------------------------------------------------
// Terrain Functions
//----------------------------------------------------------------------------------------------------------------------
HANDLE LoadTerrain(XMFLOAT3 fS, void* pRfm, int iRfm = 0, XMFLOAT3 fP = { 0, 0, 0 });
void _vectorcall SetTerrainTexture(HANDLE hTerrain, void* pRfm, int iRfm[5] = nullptr);
void _vectorcall SetTerrainTiling(HANDLE hTerrain, XMFLOAT2 fT);
void _vectorcall SetTerrainPosition(HANDLE hTerrain, XMFLOAT3 fP);
void _vectorcall SetTerrainMaterial(XMFLOAT3 fAmbient, XMFLOAT3 fDiffuse);
void DrawTerrain(HANDLE hTerrain);
void RemoveTerrain(HANDLE hTerrain);
bool TerrainExisting(HANDLE hTerrain);
bool _vectorcall TerrainTextureExisting(HANDLE hTerrain, BYTE oTexture);
float _vectorcall GetTerrainHeight(HANDLE hTerrain, float fX, float fY);
