#include "axbreeze.h"
#include "HelloWorld.h"

int WINAPI wWinMain(HINSTANCE, HINSTANCE, LPWSTR, int)
{
   WORD wWidth = 800, wHeight = 600;

   // Initialize graphics, input, and audio
   SetDisplayMode(wWidth, wHeight, 4);

   // Set foreground to blue and background to gray
   SetColor(0xff0000ff, 0xffdcdcdc);

   // Clear screen with background color
   ClearDisplay();

   // Print UNICODE text
   for(short i = 0; i < 24; i++)
   {
      SetTextDirection(i == 16 || i == 22); // Arabic or Persian (right to left)
      PrintText(40+(i/8)*250, 30+(i%8)*40, HelloWorld[i]);
   }

   // Draw some reference lines
   DrawLine(50, 350, 750, 350);
   DrawLine(50, 450, 750, 450);
   DrawLine(50, 550, 750, 550);
   DrawLine(400, 350, 400, 550);

   // Set foreground to red
   SetForeColor(0xffff0000);

   // Output text with different alignments
   DrawText(400, 0, 0, -1, L"FULL SCREEN MODE");
   DrawText(400, 350, -1, -1, L"Text aligned at left-top");
   DrawText(400, 450, 0, 0, L"Text aligned at center-center");
   DrawText(400, 550, 1, 1, L"Text aligned at right-bottom");
   SetTextAlignment(0, 1); // Align text at center-bottom
   DrawText(wWidth/2, wHeight-5, L"Press any key to exit...");

   // Present the backbuffer to screen
   UpdateDisplay();

   // Wait 20 seconds for key or mouse
   WaitVirtualKeyDown(20);
}
