#include "axbreeze.h"

int WINAPI wWinMain(HINSTANCE, HINSTANCE, LPWSTR, int)
{
   WORD wWidth = 1024, wHeight = 768;

   // Maximized windowed mode without frame
   SetDisplayMode(wWidth, wHeight, 3);

   // Clear screen with green color
   ClearDisplay(0xff00ff00);

   // Set foreground to red and background to blue
   SetColor(0xffff0000, 0xff0000ff);

   // Draw a filled rectangle with foreground color
   DrawRectangle(AXRECT(0, 0, 1024, 100), true);

   // Draw unfilled rectangle with foreground color
   DrawRectangle(AXRECT(0, 700, 1024, 67));

   // Draw unfilled and filled ellipses
   DrawEllipse(300, 400, 50, 300);
   DrawEllipse(700, 620, 300, 50, true);

   // Draw text with opaque background color
   SetTextAlignment(0, -1);
   SetForeColor(0xff0000ff);
   DrawText(wWidth/2, 0, L"MAXIMIZED WINDOWED MODE WITHOUT FRAME");
   DrawText(512, 40, L"CHANGE FONT AND PRINT SYSTEM INFORMATION");
   SetTextFont(L"Times New Roman");
   SetTextAlignment(-1, -1);
   DrawText(100, 100, L"Total processors: %d", GetLogicalProcessor());
   DrawText(400, 100, L"Total physical memory: %d", GetPhysicalMemory());
   SetTextSize(54);
   DrawText(100, 200, L"Available system memory: %d", GetSystemMemory());
   SetTextBold(true);
   SetColor(0x7fff00ff, 0x0f00ffff);
   DrawText(100, 300, L"Available video memory: %d", GetVideoMemory());
   SetTextItalic(true);
   DrawText(100, 400, L"Available disk space: %d", GetDiskSpace());
   DrawText(100, 500, L"Disk serial number: %X", GetVolumeSerial());
   SetTextAlignment(0, 1);
   DrawText(wWidth/2, wHeight, L"Press Alt-F4 to exit...");

   // Draw a filled rectangle with transparency
   SetForeColor(0x7f00ffff);
   DrawRectangle(AXRECT(0, 300, 1024, 200), true);

   // Draw a filled ellipse with transparency
   SetForeColor(0x70ffff0f);
   DrawEllipse(750, 400, 50, 200, true);

   // Enter the game loop
   while(Looping())
   {
      UpdateDisplay(100); // Desired frame per second is 100
      if(GetGameTime() >= 10.0f) break; // Exit if 10 second elapses
   }
}
