#include "axbreeze.h"
#define MAX_BUFFER 900*1024 // 900K buffer size

int WINAPI wWinMain(HINSTANCE, HINSTANCE, LPWSTR, int)
{
   BYTE pBuffer[MAX_BUFFER];

   SetDisplayMode(1024, 768);
   //DisableAlphaBlending(true);

   HANDLE hImage0 = LoadImage(L"..\\Image\\yosemite-meadows.jpg");
   HANDLE hSprite0 = LoadSprite(L"..\\Image\\audrey_kitty.gif");
   HANDLE hSprite1 = LoadSprite(L"..\\Image\\Bear_walks_2.png", 0, XMFLOAT3(-1.0f, 0.5f, -0.75f));
   UINT uSize = LoadFile(pBuffer, MAX_BUFFER, L"..\\Image\\acorns.png");
   LoadSprite(pBuffer, uSize, XMFLOAT3(-0.25f, 1.5f, -1.125f));
   LoadSprite(L"..\\Image\\amanita-muscaria.png", 0, XMFLOAT3(0.5f, 2.5f, -1.5f));
   SetSpriteScale(hSprite0, XMFLOAT2(0.25f, 0.25f));

   HANDLE hSprite4 = LoadSprite(L"..\\Image\\animated_anim3040.png", 0, XMFLOAT3(-1.15f, 1.25f, -1.125f));
   HANDLE hSprite7 = LoadSprite(L"..\\Image\\Dinosaur-01.png", 0, XMFLOAT3(-1.25f, 0.5f, -0.625f));
   SetSpriteScale(hSprite4, XMFLOAT2(1.2f, 1.2f));
   SetSpriteScale(hSprite7, XMFLOAT2(1.8f, 1.8f));

   SetSprite(hSprite0, 4, 2, 0.1f);
   SetSprite(hSprite1, 3, 2, 0.2f);
   SetSprite(hSprite4, 3, 2, 0.15f);
   SetSprite(hSprite7, 3, 3, 0.25f);
   SetSpriteFrame(hSprite7, 2);
   SetSpritePosition(hSprite0, XMFLOAT3(-1.0f, 0.75f, -0.625f));
   SetSpriteRotation(hSprite0, XMFLOAT3(0.0f, 0.0f, 0.001f));
   SetSpriteVelocity(hSprite0, XMFLOAT3(0.2f, 0.0f, -0.01f), XMFLOAT3(0.01f, -0.01f, -0.01f));
   SetSpriteVelocity(hSprite1, XMFLOAT3(0.1f, -0.015f, 0.01f), XMFLOAT3(0.01f, 0.01f, 0.01f));
   SetSpriteVelocity(hSprite4, XMFLOAT3(0.41f, 0.0f, 0.01f), XMFLOAT3(-0.01f, -0.01f, 0.0f));
   SetSpriteVelocity(hSprite7, XMFLOAT3(0.05f, 0.0f, 0.001f), XMFLOAT3(0.001f, 0.001f, 0.0f));
   SetSpriteAcceleration(hSprite0, XMFLOAT3(0.01f, 0.0f, -0.01f), XMFLOAT3(0.001f, -0.01f, -0.01f));
   SetSpriteAcceleration(hSprite4, XMFLOAT3(0.05f, 0.0f, 0.001f));
   SetSpriteAcceleration(hSprite7, XMFLOAT3(0.01f, 0.0f, 0.001f));
   WORD wFrame = GetSpriteFrame(hSprite7);
   float fTime = GetSpriteTimer(hSprite7);
   SetSpriteFrame(hSprite7, wFrame);
   SetSpriteTimer(hSprite7, fTime);
   //ShowSprite(hSprite7, 0);

   // Enter the main loop
   while(Looping())
   {
      ClearDisplay(0xff0000ff);
      DrawImage(hImage0);
      DrawSprite();
      DrawText(512, 20, 0, 0, L"Sprite depth, rotation, velocity, and acceleration");
      PrintText(8, 6, L"\f#ffff00FPS: \f#ff00ff%d", GetDisplayFrameRate());
      UpdateDisplay(0);
   }
}
