#include "axbreeze.h"
HANDLE hTimer = nullptr;
mt19937 generator;
uniform_int_distribution<UINT> color_distribution(0xFF00003F, 0xFFFFFFFF);
uniform_int_distribution<short> short_distribution(10, 800);

void AutomaticTimer()
{
   short sX = short_distribution(generator);
   short sY = short_distribution(generator);
   UINT uColor = color_distribution(generator);
   SetForeColor(uColor);
   PrintText(sX, sY, L"Text color = %X", uColor);
}

int WINAPI wWinMain(HINSTANCE, HINSTANCE, LPWSTR, int)
{
   // Initialize the display
   WORD wWidth = 1024, wHeight = 768;
   SetDisplayMode(wWidth, wHeight);

   // Create a random number generator
   hTimer = CreateTimer(0.1f, AutomaticTimer, 5.0f);
   PrintText(20, 40, L"GetTimerTotal() = %d", GetTimerTotal());

   // Enter the main loop
   while(Looping())
   {
      if(!TimerExisting(hTimer))
      {
         ClearDisplay();
         SetForeColor(0xFFFF0000);
         PrintText(20, 40, L"Timer is killed!");
         PrintText(20, 80, L"GetTimerTotal() = %d", GetTimerTotal());
      }
      UpdateDisplay(100);
   }
}
