#include "axbreeze.h"

int WINAPI wWinMain(HINSTANCE, HINSTANCE, LPWSTR, int)
{
   // Initialize graphics, input, and audio
   SetDisplayMode(200, 150);

   // Draw background triangles
   const UINT nVertex = 3;
   const UINT nIndex = 3;
   UINT uIndex[nIndex] = { 0, 1, 2 };
   UINT uColor0[nVertex] = { 0xFF00FF00, 0xFF00FF00, 0xFF00FF00 };
   XMFLOAT3 fV0[nVertex] = { { -0.1875, 0.0, -0.5 }, { 0.1875, 0.0, 0.5 }, { -0.1875, 0.0, 0.5 } };
   DrawTriangle(fV0, uColor0, nVertex, uIndex, nIndex);
   UINT uColor1[nVertex] = { 0xFF0000FF, 0xFF0000FF, 0xFF0000FF };
   XMFLOAT3 fV1[nVertex] = { { 0.1875, 0.0, 0.5 }, { -0.1875, 0.0, -0.5 }, { 0.1875, 0.0, -0.5 } };
   DrawTriangle(fV1, uColor1, nVertex, uIndex, nIndex);
   UINT uColor2[nVertex] = { 0xFFFFFF00, 0xFFFFFF00, 0xFFFFFF00 };
   XMFLOAT3 fV2[nVertex] = { { 0.015625, -0.125, 0.0625 }, { -0.0625, -0.125, -0.15625 }, { 0.046875, -0.125, -0.15625 } };
   DrawTriangle(fV2, uColor2, nVertex, uIndex, nIndex);
   UINT uColor3[nVertex] = { 0xFF00FFFF, 0xFF00FFFF, 0xFF00FFFF };
   XMFLOAT3 fV3[nVertex] = { { 0.046875, -0.125, -0.125 }, { 0.125, -0.125, 0.09375 }, { 0.03125, -0.125, 0.09375 } };
   DrawTriangle(fV3, uColor3, nVertex, uIndex, nIndex);

   // Output text at the screen center
   SetForeColor(0xffff0000);
   SetTextFont(L"SimHei", 48, true, true);
   DrawText(100, 75, 0, 0, L"N");

   HANDLE hImage = CaptureImage(AXRECT(89, 63, 32, 32));
   SaveImage(L"..\\Media\\nodapro.bmp", hImage);

   // Update display before saving
   UpdateDisplay();
   SaveDisplay(L"..\\Media\\nodapro.png");

   // Enter the game loop
   while(Looping())
   {
   }
}
