#include "axbreeze.h"

int WINAPI wWinMain(HINSTANCE, HINSTANCE, LPWSTR, int)
{
   // Initialize graphics, input, and audio
   SetDisplayMode(800, 600);

   // Clear display with gradient colors
   ClearDisplay(0xaf00ffff, 0xff7f0f7f);

   UINT uSize[3] = { 2*3*4*5*6*7*8*9, 2*11*12*13*14*15, 1000000 };
   UINT uMaximum = FactorFourierTransform(uSize);

   // Output text on the screen
   UINT uFactor;
   UINT* pFactor;
   for(BYTE i = 0; i < 3; ++i)
   {
      UINT uPermu = QueryFourierTransform(i, uFactor, pFactor);
      DrawText(20, 20+80*i, L"FFT: %u (%u factors with max %u):", uSize[i], uFactor, uPermu);
      for(UINT j = 0; j < uFactor; ++j)
      {
         DrawText(short(20+45*j), 50+80*i, L"%u", pFactor[j]);
      }
   }
   DrawText(20, 20+80*3, L"Permutation size: %u", uMaximum);

   // Enter the game loop
   while(Looping())
   {
      UpdateDisplay(60);
   }
}
