#include "axbreeze.h"
#include "resource.h"
#define MAX_BUFFER 900*1024 // 900K buffer size

int WINAPI wWinMain(HINSTANCE, HINSTANCE, LPWSTR, int)
{
   // Define an array to hold data
   BYTE pBuffer[MAX_BUFFER];

   // Initialize the display
   SetDisplayMode(800, 600);

   SetMouseCursor(OCR_HAND);
   SetColor(CombineColor(255, 0, 255, 255), CombineColor(255, 0, 0, 0));

   DrawText(10, 10, L"Just some tests");
   DrawEllipse(500, 500, 250, 250);
   DrawEllipse(600, 500, 50, 50, 0);
   SetColor(CombineColor(255, 125, 0, 255), CombineColor(255, 0, 0, 0));
   DrawRectangle(AXRECT(110, 110, 412, 1000));
   DrawRectangle(AXRECT(702, 1, 799, 599));
   DrawRectangle(AXRECT(302, 400, 306, 404));
   DrawRectangle(AXRECT(102, 305, 305, 408), true);
   DrawRectangle(AXRECT(302, 409, 304, 411));
   DrawRectangle(AXRECT(202, 412, 303, 413));
   SetColor(CombineColor(255, 0, 255, 0), CombineColor(255, 0, 0, 0));
   UINT uColor[8] = { 0xFF0000FF, 0xFF0000FF, 0xFF0000FF, 0xFF0000FF, 0xFF0FF0FF, 0xFF0FF0FF, 0xFF0FF0FF, 0xFF0FF0FF };
   DrawRectangle(XMFLOAT3(-0.8f, 0.8f, 0.5f), XMFLOAT3(1, 0, 0), XMFLOAT3(0, 1, 0), XMFLOAT2(1.0f, 0.5f), uColor);
   UINT nColor[8] = { 0xFF0000FF, 0xFF00FF00, 0xFF0000FF, 0xFF00FF00, 0xFF0000FF, 0xFF00FF00, 0xFF0000FF, 0xFF00FF00 };
   DrawLine(XMFLOAT3(-1.0f, 1.0f, 0.2f), XMFLOAT3(1.0f, -1.0f, 0.9f), nColor);
   DrawEllipse(XMFLOAT3(0.0f, 0.0f, 0.4f), XMFLOAT3(1, 0, 0), XMFLOAT3(0, 1, 0), XMFLOAT2(0.3f, 0.5f), 1);
   DrawButton(XMFLOAT3(0.5f, 0.5f, 0.2f), XMFLOAT2(0.5f, 0.5f), XMFLOAT2(0.1f, 0.1f), uColor);

   UpdateDisplay();

   // Load "greenie.png" to memory
   UINT uSize = LoadFile(pBuffer, MAX_BUFFER, L"..\\Media\\greenie.png");
   DrawText(100, 100, L"File size is %d", uSize);

   // Load image number 5 from memory (number can be 0-32767)
   HANDLE hImage5 = LoadImage(pBuffer, uSize);

   // Paste image to screen
   DrawImage(hImage5, 250, 400);

   // Paste image to screen, use alpha
   DrawImage(hImage5, 450, 400);

   // Load and play sound
   uSize = LoadFile(pBuffer, MAX_BUFFER, L"..\\Sound\\tmmadpcm.wav");
   HANDLE hSound1 = LoadSound(pBuffer, uSize);
   PlaySound(hSound1);

   // Update screen
   UpdateDisplay();

   WaitVirtualKeyDown(10.0f);
   ClearDisplay(0);

   RemoveImage(hImage5);
   hImage5 = LoadImage(L"..\\Media\\diamond.png");

   // Paste image to screen (alpha blending works)
   DrawImage(hImage5, XMFLOAT3(-0.1f, 0.1f, 0.0f), XMFLOAT3(0, 0, 0));
   DrawImage(hImage5, 200, 300);

   uSize = LoadFile(pBuffer, MAX_BUFFER, L"..\\Sound\\tmmxwma.xwm");

   RemoveSound(hSound1);
   hSound1 = LoadSound(pBuffer, uSize);
   PlaySound(hSound1);
   // Load and loop sound three times
   HANDLE hSound2 = LoadSound(L"JACKPOT", -1);
   PlaySound(hSound2, 3);

   // Update screen
   SetTextAlignment(0, -1);
   DrawText(400, 10, L"Loop sound three times (total 4 times)");
   UpdateDisplay();

   // Enter the main loop
   while(Looping())
   {
      Sleep(100);
   }
}
