#include "axbreeze.h"
#include "resource.h"
#define MAX_BUFFER 900*1024 // 900K buffer size

int WINAPI wWinMain(HINSTANCE, HINSTANCE, LPWSTR, int)
{
   BYTE pBuffer[MAX_BUFFER];

   //DisableDepthStencil(1);

   SetDisplayMode(1024, 768);

   HANDLE hBack = LoadCanvas(L"..\\Image\\yosemite-meadows.jpg");

   UINT uSize = LoadFile(pBuffer, MAX_BUFFER, L"..\\Image\\acorns.png");
   HANDLE hSprite0 = LoadSprite(pBuffer, uSize, XMFLOAT3(-1.7f, 1.68f, -1.2f));
   HANDLE hSprite1 = LoadSprite(L"..\\Image\\amanita-muscaria.png", 0, XMFLOAT3(1.0f, 1.48f, -1.27f));
   HANDLE hSprite2 = LoadSprite(L"..\\Image\\animated_anim3040.png", 0, XMFLOAT3(-1.5f, 1.47f, -1.235f));
   HANDLE hSprite3 = LoadSprite(L"..\\Image\\animated-avatar-frogwalk.png", 0, XMFLOAT3(-1.9f, 0.45f, -1.2f));
   HANDLE hSprite4 = LoadSprite(L"..\\Image\\apache-02.png", 0, XMFLOAT3(0.6f, 1.48f, 1.2f));
   HANDLE hSprite5 = LoadSprite(L"..\\Image\\audrey_kitty.gif", 0, XMFLOAT3(0.0f, 0.0f, -1.0f));
   HANDLE hSprite6 = LoadSprite(L"..\\Image\\Bear_walks_2.png", 0, XMFLOAT3(-1.6f, 1.48f, -1.26f));
   HANDLE hSprite7 = LoadSprite(L"..\\Image\\bird-02.png", 0, XMFLOAT3(-1.8f, 1.25f, 0.62f));
   HANDLE hSprite8 = LoadSprite(L"..\\Image\\Cave_man.png", 0, XMFLOAT3(1.8f, 1.38f, -1.165f));
   HANDLE hSprite9 = LoadSprite(L"..\\Image\\creatures_023.png", 0, XMFLOAT3(1.71f, 0.8f, 0.54f));
   HANDLE hSprite10 = LoadSprite(L"..\\Image\\Dinosaur-01.png", 0, XMFLOAT3(-1.71f, 1.3f, -1.178f));
   HANDLE hSprite11 = LoadSprite(L"..\\Image\\dog-09.png", 0, XMFLOAT3(-1.9f, 1.78f, -1.1f));
   HANDLE hSprite12 = LoadSprite(L"..\\Image\\Grey_puppy.png", 0, XMFLOAT3(1.9f, 1.68f, -1.21f));
   HANDLE hSprite13 = LoadSprite(L"..\\Image\\imageCA8R6WJT.png", 0, XMFLOAT3(0.0f, 1.68f, -1.23f));
   HANDLE hSprite14 = LoadSprite(L"..\\Image\\imageCANEXVR3.png", 0, XMFLOAT3(1.7f, 1.68f, -1.21f));
   HANDLE hSprite15 = LoadSprite(L"..\\Image\\imageCATLTV1G.png", 0, XMFLOAT3(-1.0f, 1.48f, -1.28f));
   HANDLE hSprite16 = LoadSprite(L"..\\Image\\wolf-01.png", 0, XMFLOAT3(-0.71f, 1.48f,-1.23f));
   HANDLE hSprite20 = CloneSprite(hSprite5);

   SetSpriteScale(hSprite0, 0.25);
   SetSpriteScale(hSprite13, 0.25);
   SetSpriteScale(hSprite14, 0.25);
   SetSpriteScale(hSprite15, 0.25);
   SetSpriteScale(hSprite16, 0.25);
   SetSpriteScale(hSprite1, XMFLOAT2(0.5f, 0.5f));
   SetSpriteScale(hSprite2, XMFLOAT2(1.2f, 1.2f));
   SetSprite(hSprite2, 3, 2, 0.1f);
   SetSpriteVelocity(hSprite2, XMFLOAT3(0.6f, 0.0f, -0.03f), XMFLOAT3(0.01f, 0.01f, 0.0f));
   SetSprite(hSprite3, 2, 3, 0.1f);
   SetSpriteVelocity(hSprite3, XMFLOAT3(0.6f, 0.0f, -0.03f), XMFLOAT3(0.01f, 0.01f, 0.0f));
   SetSprite(hSprite4, 2, 2, 0.02f);
   SetSprite(hSprite5, 4, 2, 0.1f);
   SetSpritePosition(hSprite5, XMFLOAT3(-1.0f, 0.5f, -1.5f));
   SetSpriteRotation(hSprite5, XMFLOAT3(0.0f, 0.0f, 0.3f));
   SetSpriteVelocity(hSprite5, XMFLOAT3(0.6f, 0.3f, 0.03f), XMFLOAT3(0.01f, 0.01f, 0.01f));
   SetSprite(hSprite6, 3, 2, 0.1f);
   SetSpriteVelocity(hSprite6, XMFLOAT3(0.6f, 0.0f, -0.03f), XMFLOAT3(0.01f, 0.01f, 0.0f));
   SetSprite(hSprite7, 3, 2, 0.03f);
   SetSpriteVelocity(hSprite7, XMFLOAT3(0.8f, 0.0f, 0.03f), XMFLOAT3(0.01f, 0.01f, 0.0f));
   SetSpriteAcceleration(hSprite7, XMFLOAT3(0.01f, 0.0f, 0.01f), XMFLOAT3(0.001f, 0.001f, 0.0f));
   SetSprite(hSprite8, 3, 3, 0.05f);
   SetSpriteVelocity(hSprite8, XMFLOAT3(-1.0f, 0.0f, -0.03f), XMFLOAT3(0.01f, 0.01f, 0.0f));
   SetSprite(hSprite9, 3, 2, 0.05f);
   SetSpriteVelocity(hSprite9, XMFLOAT3(-1.0f, 0.0f, -0.03f), XMFLOAT3(0.01f, 0.01f, 0.0f));
   SetSprite(hSprite10, 3, 3, 0.1f);
   SetSpriteVelocity(hSprite10, XMFLOAT3(0.6f, 0.0f, -0.03f), XMFLOAT3(0.01f, 0.01f, 0.0f));
   SetSpriteAcceleration(hSprite10, XMFLOAT3(0.02f, 0.0f, 0.0f), XMFLOAT3(0.01f, 0.01f, 0.0f));
   SetSprite(hSprite11, 2, 2, 0.05f);
   SetSpriteVelocity(hSprite11, XMFLOAT3(0.8f, 0.0f, -0.02f), XMFLOAT3(0.01f, 0.01f, 0.0f));
   SetSprite(hSprite12, 2, 2, 0.2f);
   SetSpriteVelocity(hSprite12, XMFLOAT3(-0.9f, 0.03f, 0.03f), XMFLOAT3(0.01f, 0.01f, 0.01f));
   SetSpriteAcceleration(hSprite12, XMFLOAT3(-0.11f, 0.0f, 0.01f), XMFLOAT3(0.01f, 0.01f, 0.0f));
   SetSpriteScale(hSprite20, XMFLOAT2(0.5f, 0.5f));
   SetSprite(hSprite20, 4, 2, 0.1f);
   SetSpriteRotation(hSprite20, XMFLOAT3(0.0f, 0.0f, 0.1f));
   SetSpriteVelocity(hSprite20, XMFLOAT3(0.6f, 0.3f, 0.03f), XMFLOAT3(0.021f, 0.01f, 0.01f));

   HANDLE hSound1 = LoadSound(L"..\\Sound\\horse_neigh.wav");
   HANDLE hSound2 = LoadSound(L"..\\Sound\\horse_running.wav");
   HANDLE hSound3 = LoadSound(L"..\\Sound\\frog.wav");
   HANDLE hSound4 = LoadSound(L"..\\Sound\\chopper.wav");
   HANDLE hSound5 = LoadSound(L"..\\Sound\\kitty2.wav");
   HANDLE hSound6 = LoadSound(L"..\\Sound\\bear.wav");
   HANDLE hSound7 = LoadSound(L"..\\Sound\\goose.wav");
   HANDLE hSound8 = LoadSound(L"..\\Sound\\footstep.wav");
   HANDLE hSound10 = LoadSound(L"..\\Sound\\monster.wav");
   HANDLE hSound11 = LoadSound(L"..\\Sound\\dog.wav");
   PlaySound(hSound2, 3);
   PlaySound(hSound3);
   PlaySound(hSound4, 255);
   SetSoundVolume(hSound4, 50);
   PlaySound(hSound5, 1);
   PlaySound(hSound6, 1);
   PlaySound(hSound7);
   PlaySound(hSound8, 255);
   PlaySound(hSound11, 1);

   ResetSpriteTimer();

   SetCameraFrustum(nullptr, 5.0f, 0.0f, 1000.0f);

   DrawText(30, 20, L"Once Upon a Time in Wild Wild West");

   // Enter the main loop
   while(Looping())
   {
      ClearDisplay();
      DrawCanvas(hBack);
      XMFLOAT3 fP;
      GetSpritePosition(hSprite2, fP);
      if(1.8f < fP.x && fP.x < 2.2f && !SoundPlaying(hSound1)) PlaySound(hSound1);
      GetSpritePosition(hSprite7, fP);
      if(1.6f < fP.x && fP.x < 1.9f) PlaySound(hSound7);
      if(GetSpritePosition(hSprite8, fP).x < -1.8f) StopSound(hSound8);
      GetSpritePosition(hSprite10, fP);
      if(fP.x > 0.6f) PlaySound(hSound10);
      if(fP.x > 1.8f) StopSound(hSound10);
      DrawSprite();
      PrintText(30, 50, L"FPS: \f#ff0000%d", GetDisplayFrameRate());
      PrintText(30, 80, L"System Time: \f#00ff00%.1f", GetSystemTime());
      PrintText(30, 110, L"Game Time: \f#ff00ff%.1f", GetGameTime());
      PrintText(30, 140, L"Camera view angle \f#ff0000%.1f\f~# degrees", GetCameraViewAngle(nullptr)*180.0f/XM_PI);
      UpdateDisplay(100);
   }
}
