#include "axbreeze.h"
void UpdateCameraView(); // Manipulate camera view

int WINAPI wWinMain(HINSTANCE, HINSTANCE, LPWSTR, int)
{
   WORD wWidth = 640, wHeight = 480;

   // Initialize graphics, input, and audio
   SetDisplayMode(wWidth, wHeight);

   // Set foreground color to yellow
   SetForeColor(0xFFFFFF00);
   SetBackColor(0x00000000);

   // Set text font name and font size
   SetTextFont(L"Times New Roman", 72, 1);

   HANDLE hCanvas = CreateCanvas(638, 478);
   SetCanvasCurrent(hCanvas);
   SetBackColor(0xAF00FF0F);
   ClearCanvas();
   ClearDisplay();

   // Output text at screen center
   SetTextShadow(8, 5, 0xAF1F1F1F);
   SetTextFont(L"Gabriola", 60, 1);
   SetTextOutline(7, 0xAFFFD700);
   SetTextSilhouette(4, 0xAF7FFF00);
   PrintText(wWidth/2-10, wHeight/2-20, 0, 0, L"\f+37307373\f@\f#0000ffHello\f#ff00ff, \f#ffff00World!");
   SetTextOutline(0, 0xAFFFD700);
   SetTextSilhouette(0, 0xAF7FFF00);
   SetTextFont(L"Times New Roman", 72, 1);

   // Enter the game loop
   while(Looping())
   {
      ClearDisplay(0xFF0000FF);
      SetCanvasCurrent(nullptr);
      PrintText(wWidth/2, wHeight/2, 0, 0, L"Hello, World!");
      SetCanvasMaterial(XMFLOAT3(1, 0.75, 0.5), 0.75);
      SetCanvasTexture(XMFLOAT4(0.0f, 0.0f, 0.75f, 0.65f));
      DrawCanvas(hCanvas, -70, -80, 0.75);
      SetCanvasTexture(XMFLOAT4(0.0f, 0.0f, 1.0f, 1.0f));
      DrawCanvas(hCanvas, XMFLOAT3(0.0f, 0.5f, -0.6f), XMFLOAT3(-1.2f, 0.0f, 0.0f));
      SetCanvasCurrent(hCanvas);
      ClearCanvas(AXRECT(0, 0, 300, 100));
      UpdateCameraView();
      UpdateDisplay(100);
   }
}
