#include "axbreeze.h"

void DrawWorldTriad(float fSize)
{
   static HANDLE hCanvas = nullptr;
   if(!hCanvas) // Execute once only
   {
      hCanvas = CreateCanvas(74, 32);
      SetCanvasCurrent(hCanvas);
      ClearCanvas(0);
      PrintText(0, 0, L"\f#ff0000X \f#00ff00Y \f#0000ffZ");
      SetCanvasCurrent(nullptr);
   }
   DrawTriad(XMFLOAT3(0, 0, 0), XMFLOAT3(1, 0, 0), XMFLOAT3(0, 1, 0), 0.93f*fSize);
   DrawCanvas(hCanvas, XMFLOAT3(fSize, 0, 0), 1, { 0, 0, 24, 32 });
   DrawCanvas(hCanvas, XMFLOAT3(0, fSize, 0), 1, { 25, 0, 24, 32 });
   DrawCanvas(hCanvas, XMFLOAT3(0, 0, fSize), 1, { 50, 0, 24, 32 });
}
