//----------------------------------------------------------------------------------------------------------------------
// Use Windows 8.1 SDK (included with Visual Studio Express 2013 for Windows Desktop) and DirectX SDK (June 2010)
//----------------------------------------------------------------------------------------------------------------------
#ifndef AXBREEZE
#define AXBREEZE
#define _WIN32_WINNT 0x0601 // Minimum system required
#define OEMRESOURCE // Use image identifiers defined in winuser.h
#include <map>
#include <set>
#include <random>
#include <string>
#include <thread>
#include <vector>
#include <valarray>
#include <algorithm>
#include <forward_list>
#include <windows.h>
#include <commctrl.h>
#include <C:\Program Files (x86)\Microsoft DirectX SDK (June 2010)\Include\xinput.h>
#include <dxgi1_2.h>
#include <d3d11_1.h>
#include <d2d1_1.h>
#include <directxmath.h>
#include <directxpackedvector.h>
using namespace std;
using namespace D2D1;
using namespace DirectX;
using namespace PackedVector;
#include "ax_define.h"
#include "ax_inline.h"
#include "axcamera.h"
#include "axcanvas.h"
#include "axcollision.h"
#include "axcontrol.h"
#include "axdisplay.h"
#include "axgraph.h"
#include "aximage.h"
#include "axinput.h"
#include "axlight.h"
#include "axmusic.h"
#include "axnumeric.h"
#include "axobject.h"
#include "axparticle.h"
#include "axskybox.h"
#include "axsound.h"
#include "axsprite.h"
#include "axstate.h"
#include "axsystem.h"
#include "axterrain.h"
#include "axtimer.h"
#ifdef _WIN64 // Windows 7 64-bit
#pragma comment(lib, "C:\\Program Files (x86)\\Microsoft DirectX SDK (June 2010)\\Lib\\x64\\xinput.lib")
#else // Windows 7 32-bit
#pragma comment(lib, "C:\\Program Files (x86)\\Microsoft DirectX SDK (June 2010)\\Lib\\x86\\xinput.lib")
#endif // Windows 7 platform
#pragma comment(lib, "dxgi.lib")
#pragma comment(lib, "d2d1.lib")
#pragma comment(lib, "d3d11.lib")
#pragma comment(lib, "dxguid.lib")
#pragma comment(lib, "dwrite.lib")
#pragma comment(lib, "winmm.lib")
#pragma comment(lib, "mfuuid.lib")
#pragma comment(lib, "mfplat.lib")
#pragma comment(lib, "ws2_32.lib")
#pragma comment(lib, "msimg32.lib")
#pragma comment(lib, "shlwapi.lib")
#pragma comment(lib, "comctl32.lib")
#pragma comment(lib, "iphlpapi.lib")
#pragma comment(lib, "mfreadwrite.lib")
#ifdef _DEBUG
#pragma comment(lib, "axbreezy.lib")
#else // Release
#pragma comment(lib, "axbreeze.lib")
#endif // _DEBUG
#pragma comment(linker, "\"/manifestdependency:type='win32' name='Microsoft.Windows.Common-Controls'\
        version='6.0.0.0' processorArchitecture='*' publicKeyToken='6595b64144ccf1df' language='*'\"")
#endif // AXBREEZE
