//----------------------------------------------------------------------------------------------------------------------
// Camera Functions
//----------------------------------------------------------------------------------------------------------------------
HANDLE _vectorcall CreateCamera(float fWidth, float fNear, float fFar);
HANDLE CloneCamera(HANDLE hCamera);
void SetCameraCurrent(HANDLE hCamera);
void SetCameraTopView(HANDLE hCamera);
void SetCameraBottomView(HANDLE hCamera);
void SetCameraFrontView(HANDLE hCamera);
void SetCameraBackView(HANDLE hCamera);
void SetCameraLeftView(HANDLE hCamera);
void SetCameraRightView(HANDLE hCamera);
void SetCameraIsometricView(HANDLE hCamera);
void SetCameraReverseView(HANDLE hCamera);
void SetCameraFlipView(HANDLE hCamera);
void SetCameraZoomView(HANDLE hCamera, AXRECT aRect);
void _vectorcall SetCameraFrustum(HANDLE hCamera, float fWidth, float fNear, float fFar);
void _vectorcall SetCameraViewWidth(HANDLE hCamera, float fWidth);
void _vectorcall SetCameraNearPlane(HANDLE hCamera, float fNear);
void _vectorcall SetCameraFarPlane(HANDLE hCamera, float fFar);
void _vectorcall SetCameraRadialDistance(HANDLE hCamera, float fDistance);
void _vectorcall SetCameraPosition(HANDLE hCamera, float fRho, float fTheta, float fPhi);
void _vectorcall SetCameraPosition(HANDLE hCamera, XMFLOAT3 fP, XMFLOAT3 fT, XMFLOAT3 fU);
void _vectorcall SetCameraPosition(HANDLE hCamera, XMFLOAT3 fP, XMFLOAT3 fU);
void _vectorcall SetCameraPosition(HANDLE hCamera, XMFLOAT3 fP);
void _vectorcall SetCameraTarget(HANDLE hCamera, XMFLOAT3 fT, XMFLOAT3 fU);
void _vectorcall SetCameraTarget(HANDLE hCamera, XMFLOAT3 fT);
void _vectorcall SetCameraDirection(HANDLE hCamera, XMFLOAT3 fD, XMFLOAT3 fU);
void _vectorcall SetCameraDirection(HANDLE hCamera, XMFLOAT3 fD);
void _vectorcall SetCameraUpvector(HANDLE hCamera, XMFLOAT3 fU);
void _vectorcall ShiftCamera(HANDLE hCamera, XMFLOAT3 fD);
void _vectorcall PanCamera(HANDLE hCamera, XMFLOAT3 fD);
void _vectorcall MoveCamera(HANDLE hCamera, float fDistance);
void _vectorcall PitchCamera(HANDLE hCamera, float fRadian);
void _vectorcall YawCamera(HANDLE hCamera, float fRadian);
void _vectorcall RollCamera(HANDLE hCamera, float fRadian);
void _vectorcall TurnCamera(HANDLE hCamera, XMFLOAT3 fA, float fRadian);
void _vectorcall RotateCamera(HANDLE hCamera, XMFLOAT3 fA, float fRadian);
void _vectorcall RotateCamera(HANDLE hCamera, XMFLOAT3 fR);
void RemoveCamera(HANDLE hCamera);
bool CameraExisting(HANDLE hCamera);
HANDLE GetCameraCurrent();
float _vectorcall GetCameraViewWidth(HANDLE hCamera);
float _vectorcall GetCameraViewAngle(HANDLE hCamera);
float _vectorcall GetCameraNearPlane(HANDLE hCamera);
float _vectorcall GetCameraFarPlane(HANDLE hCamera);
float _vectorcall GetCameraRadialDistance(HANDLE hCamera);
float _vectorcall GetCameraInclineAngle(HANDLE hCamera);
float _vectorcall GetCameraAzimuthAngle(HANDLE hCamera);
void _vectorcall GetCameraPosition(HANDLE hCamera, float& fRho, float& fTheta, float& fPhi);
XMFLOAT3& _vectorcall GetCameraPosition(HANDLE hCamera, XMFLOAT3& fP);
XMFLOAT3& _vectorcall GetCameraTarget(HANDLE hCamera, XMFLOAT3& fT);
XMFLOAT3& _vectorcall GetCameraHorizon(HANDLE hCamera, XMFLOAT3& fH);
XMFLOAT3& _vectorcall GetCameraDirection(HANDLE hCamera, XMFLOAT3& fD);
XMFLOAT3& _vectorcall GetCameraUpvector(HANDLE hCamera, XMFLOAT3& fU);
XMMATRIX& _vectorcall GetCameraView(HANDLE hCamera, XMMATRIX& mV);
XMMATRIX& _vectorcall GetCameraProjection(HANDLE hCamera, XMMATRIX& mP);
