//----------------------------------------------------------------------------------------------------------------------
// Canvas Functions
//----------------------------------------------------------------------------------------------------------------------
HANDLE _vectorcall CreateCanvas(WORD wX, WORD wY);
HANDLE _vectorcall LoadCanvas(void* pRfm, int iRfm = 0);
void SetCanvasCurrent(HANDLE hCanvas);
void ClearCanvas();
void ClearCanvas(AXRECT aRect);
void ClearCanvas(UINT uColor);
void ClearCanvas(UINT uTop, UINT uBottom);
void _vectorcall ClearCanvas(AXLOCK aLock, short sX, short sY);
void _vectorcall ClearCanvas(HANDLE hImage, short sX, short sY, BYTE oX = 0, BYTE oY = 0);
void _vectorcall SetCanvasTexture(XMFLOAT4 fT);
void _vectorcall SetCanvasMaterial(XMFLOAT3 fAmbient, float fAlpha);
void DrawCanvas(HANDLE hCanvas, XMFLOAT3 fP, float fScale, AXRECT aRect = { 0, 0, 0, 0 });
void DrawCanvas(HANDLE hCanvas, XMFLOAT3 fP, XMFLOAT3 fR = { 0, 0, 0 }, float fScale = 1);
void _vectorcall DrawCanvas(HANDLE hCanvas, short sX = 0, short sY = 0, float fScale = 1);
void SaveCanvas(WCHAR* pFile, HANDLE hCanvas);
void RemoveCanvas(HANDLE hCanvas);
bool CanvasExisting(HANDLE hCanvas);
HANDLE GetCanvasCurrent();
WORD GetCanvasWidth();
WORD GetCanvasHeight();
void SetColor(UINT uFore, UINT uBack);
void SetForeColor(UINT uColor);
void SetBackColor(UINT uColor);
bool SetTextFont(WCHAR* pFont);
bool _vectorcall SetTextFont(WCHAR* pFont, BYTE oSize);
bool _vectorcall SetTextFont(WCHAR* pFont, BYTE oSize, bool bBold);
bool _vectorcall SetTextFont(WCHAR* pFont, BYTE oSize, bool bBold, bool bItalic);
bool SetTextSize(BYTE oSize);
bool SetTextBold(bool bBold);
bool SetTextItalic(bool bItalic);
void SetTextOpaque(bool bOpaque);
void SetTextDirection(bool bReverse);
void SetTextAlignment(char cX, char cY);
void SetTextOutline(BYTE oThickness, UINT uColor);
void SetTextSilhouette(BYTE oThickness, UINT uColor);
void _vectorcall SetTextShadow(char cX, char cY, UINT uColor);
void _vectorcall DrawLine(short sX0, short sY0, short sX1, short sY1);
void _vectorcall DrawEllipse(short sX, short sY, WORD wX, WORD wY, bool bFill = false);
void _vectorcall DrawRoundedRectangle(AXRECT aRect, AXSIZE aRadius, bool bFill = false);
void DrawRectangle(AXRECT aRect, bool bFill = false);
void DrawText(short sX, short sY, char cX, char cY, WCHAR* pFormat, ...);
void DrawText(short sX, short sY, WCHAR* pFormat, ...);
void PrintText(short sX, short sY, char cX, char cY, WCHAR* pFormat, ...);
void PrintText(short sX, short sY, WCHAR* pFormat, ...);
UINT GetForeColor();
UINT GetBackColor();
WCHAR* GetTextFont();
BYTE GetTextSize();
BYTE GetTextStyle();
WORD GetTextWidth(WCHAR* pText);
WORD GetTextHeight(WCHAR* pText);
