//----------------------------------------------------------------------------------------------------------------------
// Display Functions
//----------------------------------------------------------------------------------------------------------------------
bool _vectorcall QueryDisplayMode(WORD wX, WORD wY);
void _vectorcall SetDisplayMode(WORD wX, WORD wY, BYTE oStyle = 0);
void SetDisplayViewport(AXRECT aRect);
bool Looping();
void ClearDisplay();
void ClearDisplay(UINT uColor);
void ClearDisplay(UINT uTop, UINT uBottom);
void UpdateDisplay(WORD wRate = 0);
void SaveDisplay(WCHAR* pFile);
void DestroyDisplay();
HWND GetDisplayParent();
HWND GetDisplayWindow();
AXSIZE GetClientSize(HWND hWindow);
AXSIZE GetWindowSize(HWND hWindow);
UINT GetDisplayFeatureLevel();
WORD GetDisplayRefreshRate();
WORD GetDisplayFrameRate();
AXSIZE GetDisplayViewportSize();
AXSIZE GetDisplayScreenSize();
AXSIZE GetDisplayClientSize();
AXSIZE GetDisplayWindowSize();
void SpeakText(WCHAR* pFormat, ...);
WCHAR* _vectorcall InputText(short sX, short sY, WORD wX);
void _vectorcall PlayMovie(void* pRfm, int iRfm = 0, bool bScale = false, void* pMovie = nullptr);
void StopMovie();
bool MoviePlaying();
UINT _vectorcall ConvertColor(UINT uColor, bool bInvert = false);
UINT _vectorcall CombineColor(BYTE oAlpha, BYTE oRed, BYTE oGreen, BYTE oBlue);
void _vectorcall SetFogColor(XMFLOAT4 fColor);
void _vectorcall SetFogStart(float fStart);
void _vectorcall SetFogRange(float fRange);
void _vectorcall SetAlphaClip(float fAlpha);
BYTE GetColorAlpha(UINT uColor);
BYTE GetColorRed(UINT uColor);
BYTE GetColorGreen(UINT uColor);
BYTE GetColorBlue(UINT uColor);
BYTE GetColorGray(UINT uColor);
XMFLOAT4 _vectorcall GetFogColor();
float _vectorcall GetFogStart();
float _vectorcall GetFogRange();
float _vectorcall GetAlphaClip();
float _vectorcall GetScreenCoordinate(short& sX, short& sY, XMFLOAT3 fP);
