//----------------------------------------------------------------------------------------------------------------------
// Image Functions
//----------------------------------------------------------------------------------------------------------------------
HANDLE _vectorcall CreateImage(WORD wX, WORD wY);
HANDLE _vectorcall LoadImage(void* pRfm, int iRfm = 0);
HANDLE CaptureImage(AXRECT aRect = { 0, 0, 0, 0 }, HANDLE hRemove = nullptr);
void CopyImage(HANDLE hSource, HANDLE hTarget);
AXLOCK LockImage(HANDLE hImage);
void UnlockImage(HANDLE hImage);
void _vectorcall DoubleImageSize(HANDLE hSource, HANDLE hTarget, bool bSwap = false);
void _vectorcall SetImageMaterial(XMFLOAT3 fAmbient, float fAlpha);
void DrawImage(HANDLE hImage, XMFLOAT3 fP, XMFLOAT3 fR = { 0, 0, 0 }, float fScale = 1, bool bCull = false);
void DrawImage(HANDLE hImage, short sX = 0, short sY = 0, AXRECT aRect = { 0, 0, 0, 0 }, float fScale = 1);
void PasteImage(HANDLE hImage, HANDLE hCanvas = nullptr, XMFLOAT2 fS = { 1, 1 });
void SaveImage(WCHAR* pFile, HANDLE hImage);
void RemoveImage(HANDLE hImage);
bool ImageExisting(HANDLE hImage);
WORD GetImageWidth(HANDLE hImage);
WORD GetImageHeight(HANDLE hImage);
