//----------------------------------------------------------------------------------------------------------------------
// Light Functions
//----------------------------------------------------------------------------------------------------------------------
HANDLE _vectorcall CreateLight(XMFLOAT3 fP, XMFLOAT3 fD, XMFLOAT2 fS, float fFar, float fAmbient = 0);
HANDLE CloneLight(HANDLE hLight);
void SetLightCurrent(HANDLE hLight);
void SetLightType(HANDLE hLight, BYTE oType);
void _vectorcall SetLightType(HANDLE hLight, BYTE oType, BYTE oPower);
void _vectorcall SetLightColor(HANDLE hLight, XMFLOAT3 fC, float fAmbient);
void _vectorcall SetLightAttenuation(HANDLE hLight, XMFLOAT3 fA);
void _vectorcall SetLightPosition(HANDLE hLight, XMFLOAT3 fP, XMFLOAT3 fD, XMFLOAT3 fU);
void _vectorcall SetLightPosition(HANDLE hLight, XMFLOAT3 fP, XMFLOAT3 fU);
void _vectorcall SetLightPosition(HANDLE hLight, XMFLOAT3 fP);
void _vectorcall SetLightTarget(HANDLE hLight, XMFLOAT3 fT);
void _vectorcall SetLightDirection(HANDLE hLight, XMFLOAT3 fD);
void _vectorcall SetLightUpvector(HANDLE hLight, XMFLOAT3 fU);
void _vectorcall SetLightSize(HANDLE hLight, XMFLOAT2 fS, float fFar);
void _vectorcall ShiftLight(HANDLE hLight, XMFLOAT3 fD);
void _vectorcall TurnLight(HANDLE hLight, XMFLOAT3 fP, XMFLOAT3 fA, float fRadian);
void RemoveLight(HANDLE hLight);
bool LightExisting(HANDLE hLight);
HANDLE GetLightCurrent();
BYTE GetLightType(HANDLE hLight);
BYTE GetLightPower(HANDLE hLight);
XMFLOAT3& _vectorcall GetLightColor(HANDLE hLight, XMFLOAT3& fC, bool bAmbient = false);
XMFLOAT3& _vectorcall GetLightAttenuation(HANDLE hLight, XMFLOAT3& fA);
XMFLOAT3& _vectorcall GetLightPosition(HANDLE hLight, XMFLOAT3& fP);
XMFLOAT3& _vectorcall GetLightHorizon(HANDLE hLight, XMFLOAT3& fH);
XMFLOAT3& _vectorcall GetLightDirection(HANDLE hLight, XMFLOAT3& fD);
XMFLOAT3& _vectorcall GetLightUpvector(HANDLE hLight, XMFLOAT3& fU);
XMFLOAT2& _vectorcall GetLightSize(HANDLE hLight, XMFLOAT2& fS);
float _vectorcall GetLightViewAngle(HANDLE hLight);
float _vectorcall GetLightNearPlane(HANDLE hLight);
float _vectorcall GetLightFarPlane(HANDLE hLight);
