//----------------------------------------------------------------------------------------------------------------------
// Skybox Functions
//----------------------------------------------------------------------------------------------------------------------
HANDLE LoadSkybox(XMFLOAT3 fS, void* pRfm, int iRfm[6] = nullptr, XMFLOAT3 fP = { 0, 0, 0 });
void _vectorcall SetSkyboxSize(HANDLE hSkybox, XMFLOAT3 fS);
void _vectorcall SetSkyboxPosition(HANDLE hSkybox, XMFLOAT3 fP);
void _vectorcall SetSkyboxMaterial(XMFLOAT3 fAmbient);
void DrawSkybox(HANDLE hSkybox);
void RemoveSkybox(HANDLE hSkybox);
bool SkyboxExisting(HANDLE hSkybox);
XMFLOAT3& _vectorcall GetSkyboxSize(HANDLE hSkybox, XMFLOAT3& fS);
XMFLOAT3& _vectorcall GetSkyboxPosition(HANDLE hSkybox, XMFLOAT3& fP);
