//----------------------------------------------------------------------------------------------------------------------
// Sprite Functions
//----------------------------------------------------------------------------------------------------------------------
HANDLE CreateSprite(HANDLE hImage, XMFLOAT3 fP = { 0, 0, 0 });
HANDLE LoadSprite(void* pRfm, int iRfm = 0, XMFLOAT3 fP = { 0, 0, 0 });
HANDLE CloneSprite(HANDLE hSprite, XMFLOAT3 fD = { 0, 0, 0 });
void _vectorcall SetSpriteScale(HANDLE hSprite, float fScale);
void _vectorcall SetSpriteScale(HANDLE hSprite, XMFLOAT2 fS);
void _vectorcall SetSpritePosition(HANDLE hSprite, XMFLOAT3 fP);
void _vectorcall SetSpriteRotation(HANDLE hSprite, XMFLOAT3 fR);
void SetSpriteVelocity(HANDLE hSprite, XMFLOAT3 fV, XMFLOAT3 fW = { 0, 0, 0 });
void SetSpriteAcceleration(HANDLE hSprite, XMFLOAT3 fA, XMFLOAT3 fB = { 0, 0, 0 });
void _vectorcall SetSpriteMaterial(HANDLE hSprite, XMFLOAT3 fAmbient, XMFLOAT3 fDiffuse);
void _vectorcall SetSpriteBillboard(HANDLE hSprite, bool bEnable, bool bPartial, bool bUpright);
void _vectorcall SetSprite(HANDLE hSprite, BYTE oX, BYTE oY, float fDelay, WORD wStart = 0, WORD wEnd = -1);
void _vectorcall SetSpriteTimer(HANDLE hSprite, float fTime);
void SetSpriteFrame(HANDLE hSprite, WORD wFrame);
void ResetSpriteTimer(HANDLE hSprite);
void ResetSpriteTimer();
void ResetSprite(HANDLE hSprite);
void ResetSprite();
void ShowSprite(HANDLE hSprite, bool bShow);
void ShowSprite(bool bShow);
void DrawSprite(HANDLE hSprite = nullptr);
void RemoveSprite(HANDLE hSprite);
bool SpriteExisting(HANDLE hSprite);
bool SpriteVisible(HANDLE hSprite);
WORD GetSpriteWidth(HANDLE hSprite);
WORD GetSpriteHeight(HANDLE hSprite);
WORD GetSpriteFrame(HANDLE hSprite);
float _vectorcall GetSpriteTimer(HANDLE hSprite);
XMFLOAT2& _vectorcall GetSpriteScale(HANDLE hSprite, XMFLOAT2& fS);
float _vectorcall GetSpriteScaleX(HANDLE hSprite);
float _vectorcall GetSpriteScaleY(HANDLE hSprite);
XMFLOAT3& _vectorcall GetSpritePosition(HANDLE hSprite, XMFLOAT3& fP);
float _vectorcall GetSpritePositionX(HANDLE hSprite);
float _vectorcall GetSpritePositionY(HANDLE hSprite);
float _vectorcall GetSpritePositionZ(HANDLE hSprite);
XMFLOAT3& _vectorcall GetSpriteRotation(HANDLE hSprite, XMFLOAT3& fR);
float _vectorcall GetSpriteRotationX(HANDLE hSprite);
float _vectorcall GetSpriteRotationY(HANDLE hSprite);
float _vectorcall GetSpriteRotationZ(HANDLE hSprite);
