//----------------------------------------------------------------------------------------------------------------------
// System Functions
//----------------------------------------------------------------------------------------------------------------------
void SetWindowTitle(WCHAR* pTitle);
void SetWindowIcon(WCHAR* pIcon);
void SetWindowIcon(WORD wIcon);
void PauseGameTime();
void ResumeGameTime();
void _vectorcall Snooze(float fSecond);
float _vectorcall GetSystemTime();
float _vectorcall GetGameTime();
UINT GetGameTick();
WCHAR* GetDateTime();
WCHAR* GetProcessorIdentity();
WCHAR* GetNetworkIdentity(BYTE oAdapter = 0);
BYTE GetLogicalProcessor();
UINT GetPhysicalMemory();
UINT GetSystemMemory();
UINT GetVideoMemory();
UINT GetDiskSpace();
UINT GetVolumeSerial();
AXSIZE GetMonitorSize();
UINT _vectorcall LoadResource(BYTE*& pBuffer, WCHAR* pResource);
UINT _vectorcall LoadResource(BYTE*& pBuffer, UINT uResource);
UINT _vectorcall LoadFile(void* pBuffer, UINT uBuffer, WCHAR* pFile);
UINT _vectorcall SaveFile(WCHAR* pFile, void* pBuffer, UINT uBuffer);
UINT _vectorcall SaveText(WCHAR* pFile, WCHAR* pText, bool bAppend = false);
void RemoveFile(WCHAR* pFile);
bool FileExisting(WCHAR* pFile);
UINT GetFileSize(WCHAR* pFile);
UINT64 GetFileTime(WCHAR* pFile);
WCHAR* GetFileStamp(WCHAR* pFile);
bool MakeDirectory(WCHAR* pPath);
void SetWorkDirectory(WCHAR* pPath);
void RemoveDirectory(WCHAR* pPath);
bool DirectoryExisting(WCHAR* pPath);
WCHAR* GetWorkDirectory();
WCHAR* GetExecutableName();
UINT GetRandom(BYTE oRandom = 0);
void SetRandom(UINT uSeed, BYTE oRandom = 0);
