#include "axbreeze.h"

int WINAPI wWinMain(HINSTANCE, HINSTANCE, LPWSTR, int)
{
   WORD wWidth = 1024, wHeight = 768;

   // Initialize graphics, input, and audio
   SetDisplayMode(wWidth, wHeight);
   ClearDisplay(0xff00007f);

   // Load "F4.GIF" to image number 0
   HANDLE hImage0 = LoadImage(L"..\\Image\\F4.GIF");
   HANDLE hImage1 = CreateImage(2*GetImageWidth(hImage0), 2*GetImageHeight(hImage0));
   DoubleImageSize(hImage0, hImage1, 1);

   // Paste image 0 and image 1 to screen
   PrintText(352, 204, L"Original image");
   DrawImage(hImage0, 392, 224);
   PrintText(132, 344, L"Original image scaled");
   DrawImage(hImage0, 172, 354, { 0, 0, 0, 0 }, 2);
   PrintText(482, 344, L"Double sized image");
   DrawImage(hImage1, 492, 354);

   // Load and play wave sound number 0
   HANDLE hSound[4];
   hSound[0] = LoadSound(L"..\\Sound\\tmmpcm.mp3");
   for(short i = 1; i < 4; i++)
   {
      hSound[i] = CloneSound(hSound[0]);
   }
   RemoveSound(hSound[1]);
   PrintText(25, 25, -1, -1, L"Total sound number = %d", GetSoundTotal());
   PlaySound(hSound[3]);
   Snooze(0.2f);

   SetForeColor(0xffff0000);
   SetBackColor(0xff00ffff);
   PrintText(70, 100, L"Input a string");
   PrintText(70, 150, L"You entered \f#ffff00%s", InputText(250, 100, 340));
   int n1, n2;
   SetBackColor(0xff00ff00);
   PrintText(50, 600, L"Input two numbers separated by space");
   swscanf_s(InputText(50, 640, 340), L"%d %d", &n1, &n2);
   SetForeColor(0xffff00ff);
   PrintText(50, 680, L"You entered %d and %d", n1, n2);

   // Enter the game loop
   while(Looping())
   {
      UpdateDisplay();
      Sleep(50);
   }
}
