#include "axbreeze.h"
#define MAX_BUFFER 900*1024 // 900K buffer size

int WINAPI wWinMain(HINSTANCE, HINSTANCE, LPWSTR, int)
{
   // Define an array to hold data
   BYTE pBuffer[MAX_BUFFER];

   // Initialize the display and load a canvas (..\\Image\\helloworld.jpg)
   SetDisplayMode(900, 675);
   HANDLE hCanvas = LoadCanvas(L"..\\Image\\helloworld.jpg");

   UINT uSize = LoadFile(pBuffer, MAX_BUFFER, L"..\\Sound\\kitty1.wav");
   HANDLE hSound0 = LoadSound(pBuffer, uSize);
   PlaySound(hSound0, 1);

   HANDLE hSprite[20];
   hSprite[0] = LoadSprite(L"..\\Image\\audrey_kitty.gif");
   hSprite[1] = LoadSprite(L"..\\Image\\dog-09.png", 0, XMFLOAT3(-2.0f, 1.5f, -1.25f));
   SetSprite(hSprite[0], 4, 2, 0.1f);
   SetSprite(hSprite[1], 2, 2, 0.125f);
   SetSpriteScale(hSprite[1], 3);
   SetSpritePosition(hSprite[0], XMFLOAT3(0.0f, 0.5f, -0.5f));
   SetSpriteRotation(hSprite[0], XMFLOAT3(0.0f, 0.0f, 0.1f));
   SetSpriteVelocity(hSprite[0], XMFLOAT3(0.02f, -0.1f, 0.01f), XMFLOAT3(0.01f, 0.01f, 0.01f));
   SetSpriteVelocity(hSprite[1], XMFLOAT3(0.2f, -0.05f, 0.1f), XMFLOAT3(0.01f, 0.01f, 0.01f));
   SetSpriteMaterial(hSprite[1], XMFLOAT3(1.0f, 0.5f, 0.5f), XMFLOAT3(0.2f, 0.5f, 0.5f));
   hSprite[2] = CloneSprite(hSprite[0]);
   SetSpriteScale(hSprite[2], XMFLOAT2(0.5f, 0.5f));
   SetSprite(hSprite[2], 4, 2, 0.1f);
   SetSpritePosition(hSprite[2], XMFLOAT3(-0.25f, 0.5f, -0.75f));
   SetSpriteRotation(hSprite[2], XMFLOAT3(0.0f, 0.0f, 0.1f));
   SetSpriteVelocity(hSprite[2], XMFLOAT3(0.2f, -0.1f, 0.1f), XMFLOAT3(0.01f, 0.01f, 0.01f));
   for(short i = 3; i < 20; i++)
   {
      hSprite[i] = CloneSprite(hSprite[i-1]);
      SetSpriteScale(hSprite[i], XMFLOAT2(0.6f, 0.6f));
      SetSprite(hSprite[i], 4, 2, 0.1f);
      SetSpritePosition(hSprite[i], XMFLOAT3(-2.0f+0.1f*i+0.125f*short(i/8), 0.9f-0.02f*i, 0.05f*i-0.5f));
      SetSpriteRotation(hSprite[i], XMFLOAT3(0.0f, 0.0f, 0.1f));
      SetSpriteVelocity(hSprite[i], XMFLOAT3(0.2f, -0.1f, 0.01f), XMFLOAT3(0.01f, 0.01f, 0.01f));
      SetSpriteMaterial(hSprite[i], XMFLOAT3((rand()%256)/255.0f, (rand()%256)/255.0f, (rand()%256)/255.0f), XMFLOAT3(0.5f, 0.5f, 0.5f));
   }

   for(short i = 10; i < 20; i++)
   {
//      RemoveSprite(hSprite[i]);
   }
//   RemoveSprite(hSprite[0]);

   SetTextAlignment(0, -1);
   SetColor(CombineColor(125, 255, 255, 0), CombineColor(255, 0, 0, 0));
   SetImageMaterial(XMFLOAT3(1.0f, 0.8f, 1.0f), 1);

   // Enter the main loop
   while(Looping())
   {
      ClearDisplay();
      DrawCanvas(hCanvas, XMFLOAT3(0, 10, 0), 0.4f);
      DrawSprite();
      DrawLine(XMFLOAT3(-4.0f, 0.0f, -2.0f), XMFLOAT3(4.0f, 1.0f, 2.8f));
      DrawLine(0, 628, 899, 628);
      DrawLine(899, 668, 0, 668);
      PrintText(5, 580, -1, -1, L"Total sprite number = %d", GetSpriteTotal());
      DrawText(450, 630, L"An army of cloned cats");
      UpdateDisplay(100);
   }
}
