#include "axbreeze.h"
const UINT MAXNUM = 2147483645;
const UINT NSLICE = 100;
const UINT NWIDTH = MAXNUM/NSLICE;
UINT uBuffer[NSLICE] = { 0 };
UINT uMaximum = 1;
UINT uMaxNum = 0;
UINT uMinNum = MAXNUM;

int WINAPI wWinMain(HINSTANCE, HINSTANCE, LPWSTR, int)
{
   // Initialize the display
   WORD wWidth = 1024, wHeight = 768;
   SetDisplayMode(wWidth, wHeight);

   // Set foreground color
   SetForeColor(0xFF00FFFF);

   // Enter the main loop
   while(Looping())
   {
      UINT uTotal = 0;
      UINT uRandom = GetRandom();
      if(uMaxNum < uRandom) uMaxNum = uRandom;
      if(uMinNum > uRandom) uMinNum = uRandom;
      for(UINT i = 0; i < NSLICE; i++)
      {
         if(i*NWIDTH <= uRandom && uRandom < (i+1)*NWIDTH) uBuffer[i]++;
         if(uMaximum < uBuffer[i]) uMaximum = uBuffer[i];
         uTotal += uBuffer[i];
      }
      if(uTotal%1000) continue;
      ClearDisplay();
      for(WORD i = 0; i < NSLICE; i++)
      {
         WORD wBar = WORD(float(wHeight-100)*uBuffer[i]/uMaximum);
         DrawRectangle(AXRECT(i*wWidth/NSLICE, wHeight-wBar, wWidth/NSLICE, wBar), 1);
      }
      PrintText(10, 10, L"Random number frequency plot (uMaxNum = %u, uMinNum = %u)", uMaxNum, uMinNum);
      PrintText(10, 50, L"\f#ffff00Total frequency = \f#ff00ff%u\f#ffff00, Maximum frequency = \f#ff00ff%u", uTotal, uMaximum);
      UpdateDisplay();
   }
}
