#include "axbreeze.h"

int WINAPI wWinMain(HINSTANCE, HINSTANCE, LPWSTR, int)
{
   WORD wWidth = 640, wHeight = 480;

   // Initialize graphics, input, and audio
   SetDisplayMode(wWidth, wHeight);

   // Set foreground color to yellow
   SetForeColor(0xFF00FF00);
   SetBackColor(0xFFFF00FF);

   HANDLE hImage0 = LoadImage(L"..\\Media\\diamond.png");

   // Output text at canvas center
   HANDLE hCanvas0 = CreateCanvas(GetImageWidth(hImage0), GetImageHeight(hImage0));
   SetCanvasCurrent(hCanvas0);
   AXLOCK aLock = LockImage(hImage0); // Lock specified image
   ClearCanvas(aLock, 0, 0);
   UnlockImage(hImage0); // Unlock specified image
   SetTextShadow(4, 3, 0xFF070707);
   SetTextFont(L"Times New Roman", 28, 1);
   DrawText(50, 65, 0, 0, L"Hello, World!");

   HANDLE hCanvas1 = CreateCanvas(400, 400);
   SetCanvasCurrent(hCanvas1);
   ClearCanvas(hImage0, 2, 1, 3, 2);
   SetTextFont(L"Times New Roman", 48, 1);
   DrawText(200, 65, 0, 0, L"Hello, World!");

   SetCanvasCurrent(nullptr);
   SetTextFont(L"Gabriola", 80, 1);
   SetTextShadow(8, 5, 0xAF1F1F1F);
   SetTextOutline(6, 0xAF00FF00);
   SetTextSilhouette(4, 0xAF0000FF);
   PasteImage(hImage0, hCanvas0, XMFLOAT2(0.5, 0.25));

   // Enter the game loop
   while(Looping())
   {
      ClearDisplay(0xAF00FFFF, 0xAFFFFF00);
      DrawCanvas(hCanvas0, 1, 1);
      DrawCanvas(hCanvas0, 538, 1);
      DrawCanvas(hCanvas1, 120, 40);
      PrintText(wWidth/2-10, wHeight/2-20, 0, 0, L"\f+37307373\f@\f#0000ffHello\f#00ffff, \f#ff0000World!");
      UpdateDisplay(100);
   }
}
