#include "axbreeze.h"
#include "resource.h"
#define MAX_BUFFER 900*1024 // 900K buffer size

int WINAPI wWinMain(HINSTANCE, HINSTANCE, LPWSTR, int)
{
   // Define an array to hold data
   BYTE pBuffer[MAX_BUFFER];

   // Initialize the display
   SetDisplayMode(800, 600);

   SetWindowIcon(L"IDI_ICON1");

   DisableAlphaBlending(1);

   SetForeColor(CombineColor(255, 0, 255, 0));

   // Load "diamond.png" to memory
   LoadFile(pBuffer, MAX_BUFFER, L"..\\Media\\diamond.png");

   SetForeColor(CombineColor(255, 0, 255, 255));
   DrawEllipse(XMFLOAT3(0.0f, 1.0f, 0), XMFLOAT3(1, 1, 0), XMFLOAT3(0, 1, 1), XMFLOAT2(0.3f, 0.3f), 0xffff0000, true);
   DrawEllipse(500, 500, 150, 150);
   SetTextAlignment(0, 0);
   DrawText(40, 400, L"Hello!");
   UpdateDisplay();
   Snooze(1.0f);

   // Load image number 5 from memory
   UINT uSize = LoadFile(pBuffer, MAX_BUFFER, L"..\\Media\\nodapro.bmp");
   HANDLE hImage4 = LoadImage(pBuffer, uSize);
   HANDLE hImage5 = LoadImage(L"..\\Media\\greenie.png");
   DrawImage(hImage4, 10, 10);
   DrawImage(hImage5, 102, 1);
   DrawImage(hImage5, 0, 469);
   DrawImage(hImage5, 102, 468);
   DrawText(1024/2, 768/2, L"%d", GetImageWidth(hImage5));
   DrawText(1024/2+80, 768/2, L"%d", GetImageHeight(hImage5));

   // Update screen
   SetTextAlignment(0, -1);
   DrawText(600, 10, L"Various stuff again");
   UpdateDisplay();

   // Reset the display
   SetDisplayMode(900, 700);
   SetTextAlignment(0, -1);
   DrawText(400, 60, L"Sound and music together, mp3 format sound is used");
   UpdateDisplay();

   uSize = LoadFile(pBuffer, MAX_BUFFER, L"..\\Sound\\tmmpcm.mp3");
   HANDLE hSound0 = LoadSound(pBuffer, uSize);
   HANDLE hSound1 = LoadSound(L"..\\Sound\\jackpot.wav");
   PlaySound(hSound0, 255);
   Snooze(5.0f);
   PauseSound(hSound0);
   ResumeSound(hSound0);
   PlaySound(hSound1, 255);
   uSize = LoadFile(pBuffer, MAX_BUFFER, L"..\\Music\\ch5_13.mid");
   HANDLE hMusic0 = LoadMusic(pBuffer, uSize);
   HANDLE hMusic1 = LoadMusic(L"..\\Music\\ch5_24.mid");
   DisableMusicPause(1);
   PlayMusic(hMusic0, 1);
   Snooze(9.0f);
   PauseMusic();
   Snooze(3.0f);
   ResumeMusic();
   Snooze(2.0f);
   PlayMusic(hMusic1, 2);
   SetMusicVolume(200);

   // Enter the main loop
   while(Looping())
   {
      UpdateDisplay();
      Snooze(1.0f);
   }
}
