#include "axbreeze.h"
#include "resource.h"
#define MAX_BUFFER 900*1024 // 900K buffer size

int WINAPI wWinMain(HINSTANCE, HINSTANCE, LPWSTR, int)
{
   // Define an array to hold data
   BYTE pBuffer[MAX_BUFFER];

   // Initialize the display
   SetDisplayMode(900, 700);

   SetWindowIcon(IDI_ICON2);

   DisableAlphaBlending(1);

   SetColor(CombineColor(200, 255, 255, 0), CombineColor(255, 0, 0, 0));
   DrawLine(799, 599, 799, 0);
   DrawLine(799, 599, 0, 599);
   DrawLine(0, 599, 0, 0);
   DrawLine(799, 0, 0, 0);
   SetGraphMaterial(1.25f, 1.25f, 1);

   // Load image number 4 from memory
   UINT uSize = LoadFile(pBuffer, MAX_BUFFER, L"..\\Image\\lava-4.jpg");
   HANDLE hImage4 = LoadImage(pBuffer, uSize);
   HANDLE hImage5 = LoadImage(L"..\\Media\\diamond.png");
   HANDLE hImage6 = LoadImage(L"BLUEIMG", -1);

   // Paste image to screen, use alpha
   DrawImage(hImage4, XMFLOAT3(0.0f, 0.25f, 0.0f), XMFLOAT3(0, 0, 0));
   DrawImage(hImage5, XMFLOAT3(-0.45f, 0.1f, -0.1f), XMFLOAT3(0, 0, 0));
   DrawImage(hImage6, XMFLOAT3(-0.125f, 0.0f, 0.0f), XMFLOAT3(0, 0, 0));

   SetTextAlignment(0, 0);
   DrawText(212, 288, L"%d", GetImageWidth(hImage5));
   DrawText(125, 400, L"%d", GetImageHeight(hImage5));

   // Load sprite number 6 from image
   HANDLE hSprite6 = LoadSprite(L"BLUEIMG", -1);
   SetSpritePosition(hSprite6, XMFLOAT3(0.2f, -0.1f, 0.25f));
   SetSpriteScale(hSprite6, 0.5f);
   UpdateDisplay();
   Sleep(1000);

   HANDLE hSprite0 = LoadSprite(L"..\\Media\\diamond.png", 0);
   HANDLE hSprite1 = LoadSprite(L"BLUEIMG", -1);
   SetSpritePosition(hSprite0, XMFLOAT3(-0.2f, -0.2f, 0.25f));
   SetSpritePosition(hSprite1, XMFLOAT3(-0.3f, -0.3f, -0.25f));
   SetSprite(hSprite0, 2, 2, 0.5f);
   SetSprite(hSprite1, 2, 2, 0.5f);

   SetTextAlignment(0, -1);
   DrawText(600, 10, L"Alpha blending is disabled");

   // Enter the main loop
   while(Looping())
   {
      DrawSprite();
      UpdateDisplay();
   }
}
