#include "axbreeze.h"

void UpdateCameraView()
{
   PrintText(8, 6, L"\f#ffff00FPS: \f#ff00ff%d", GetDisplayFrameRate());

   short sDx = 0, sDy = 0, sDz = 0;
   const float fDs = 0.002f, fDt = 0.1f;
   float fDx = 0.0f, fDy = 0.0f, fDz = 0.0f;

   GetMouseMove(MK_CONTROL | MK_LBUTTON | MK_MBUTTON | MK_RBUTTON, sDx, sDy, sDz);
   fDx -= fDs*sDy;
   fDy -= fDs*sDx;
   fDz -= 5.0f*fDs*sDz;

   if(PollUpKey()) fDx += fDt;
   if(PollDownKey()) fDx -= fDt;
   if(PollLeftKey()) fDy += fDt;
   if(PollRightKey()) fDy -= fDt;
   if(PollShiftKey()) fDz += fDt;
   if(PollControlKey()) fDz -= fDt;

   PitchCamera(nullptr, fDx);
   TurnCamera(nullptr, XMFLOAT3(0.0f, 0.0f, 1.0f), fDy);
   //RotateCamera(nullptr, XMFLOAT3(0.0f, 1.0f, 0.0f), fDy);
   MoveCamera(nullptr, fDz);
}
