#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define N_STRING 1024
char szFile[256] = { 0 };
char szLine[N_STRING] = { 0 };
char szList[] = "build_xall.txt";
char szHead[] = "Source\\";
char szName[] = ".vcxproj";

int main(int argc, char *argv[])
{
   if(argc < 2) return -1;

   FILE *fa, *fr, *fw;

   fopen_s(&fa, szList, "rt");
   if(fa == NULL) return -1;

   while(fgets(szFile, N_STRING, fa))
   {
      sprintf(szLine, "%s%c000%s", szHead, szFile[0], szName);
      fopen_s(&fr, szLine, "rt");
      if(fr == NULL) continue;

      char szTemp[256] = { 0 };
      sprintf(szTemp, "%s%s", szHead, szFile);
      sprintf(strstr(szTemp, "."), "%s", szName);
      fopen_s(&fw, szTemp, "wt");
      if(fw == NULL)
      {
         printf("Unable to open %s\n", szTemp);
         fclose(fr);
         continue;
      }

      while(fgets(szLine, N_STRING, fr))
      {
         char szCompile[] = "    <ClCompile Include=\"";
         char szProject[] = "    <ProjectName>";
         if(strstr(szLine, szCompile) && szLine[strlen(szCompile)] == szFile[0])
         {
            szFile[strlen(szFile)-1] = 0;
            fprintf(fw, "%s%s\" />\n", szCompile, szFile);
         }
         else if(strstr(szLine, szProject) && szLine[strlen(szProject)] == szFile[0])
         {
            szFile[strlen(szFile)-4] = 0;
            fprintf(fw, "%s%s</ProjectName>\n", szProject, szFile);
         }
         else fputs(szLine, fw);
      }

      fclose(fw);
      fclose(fr);

      sprintf(szLine, "msbuild %s /p:configuration=Release /p:platform=%s", szTemp, argv[1]);
      system(szLine);
      sprintf(szLine, "del /Q %s", szTemp);
      system(szLine);
      sprintf(szLine, "rmdir /S /Q %sTemp", szHead);
      system(szLine);
      sprintf(szLine, "move /Y %sBin\\*.* Bin", szHead);
      system(szLine);
   }

   fclose(fa);

   return 0;
}
